"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
require("rxjs/add/operator/startWith");
var core_1 = require("@angular/core");
var DraggableDirective = (function () {
    function DraggableDirective(el, renderer) {
        this.el = el;
        this.renderer = renderer;
        // I dont quite understand how it was working without this
        this.dragging = false;
        this.Δx = 0;
        this.Δy = 0;
        this.mustBePosition = ['absolute', 'fixed', 'relative'];
        try {
            if (this.mustBePosition.indexOf(this.el.nativeElement.style.position) === -1) {
                this.el.nativeElement.style.position = "relative";
                console.warn(this.el.nativeElement, 'Must be having position attribute set to ' + this.mustBePosition.join('|') + ", defaulting to relative.");
            }
        }
        catch (ex) {
            console.error(ex);
        }
    }
    DraggableDirective.prototype.onMouseup = function (event) {
        this.Δx = 0;
        this.Δy = 0;
        this.dragging = false;
    };
    DraggableDirective.prototype.onMousedown = function (event) {
        // I still want to be able to finish the drag even if draggable changes during the movement
        // So I'm checking this only here 
        if (this.draggable) {
            event.preventDefault();
            this.Δx = event.x - this.el.nativeElement.offsetLeft;
            this.Δy = event.y - this.el.nativeElement.offsetTop;
            this.dragging = true;
        }
    };
    DraggableDirective.prototype.onMousemove = function (event) {
        if (this.dragging) {
            this.doTranslation(event.x, event.y);
        }
    };
    DraggableDirective.prototype.ngOnInit = function () {
        this.renderer.setElementAttribute(this.el.nativeElement, 'draggable', 'true');
    };
    DraggableDirective.prototype.ngOnDestroy = function () {
        this.renderer.setElementAttribute(this.el.nativeElement, 'draggable', 'false');
    };
    DraggableDirective.prototype.doTranslation = function (x, y) {
        if (!x || !y) {
            return;
        }
        this.renderer.setElementStyle(this.el.nativeElement, 'top', (y - this.Δy) + 'px');
        this.renderer.setElementStyle(this.el.nativeElement, 'left', (x - this.Δx) + 'px');
    };
    return DraggableDirective;
}());
__decorate([
    core_1.Input('draggable'),
    __metadata("design:type", Boolean)
], DraggableDirective.prototype, "draggable", void 0);
__decorate([
    core_1.HostListener('mouseup', ['$event']),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [MouseEvent]),
    __metadata("design:returntype", void 0)
], DraggableDirective.prototype, "onMouseup", null);
__decorate([
    core_1.HostListener('mousedown', ['$event']),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [MouseEvent]),
    __metadata("design:returntype", void 0)
], DraggableDirective.prototype, "onMousedown", null);
__decorate([
    core_1.HostListener('mousemove', ['$event']),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [MouseEvent]),
    __metadata("design:returntype", void 0)
], DraggableDirective.prototype, "onMousemove", null);
DraggableDirective = __decorate([
    core_1.Directive({
        selector: '[draggable]'
    }),
    __metadata("design:paramtypes", [core_1.ElementRef, core_1.Renderer])
], DraggableDirective);
exports.DraggableDirective = DraggableDirective;
//# sourceMappingURL=draggable.directive.js.map